Skip to navigation

How to add forms to a room

View as Markdown
Docusign Rooms for Real Estate only

This topic demonstrates how to attach forms to a room using the Rooms API.

Run this code example from our Quickstart or launcher projects: Bash, C#, Java, Node.js, PHP, PowerShell, Python, or Ruby.

Required data

Running the code in this how-to requires this data:

Data elementDescription
{API_ACCOUNT_ID}A GUID value that identifies your account. This value is automatically generated by Docusign for any account you create. Copy the value from the API Account ID field on the Apps and Keys page.
{BASE_PATH}A string value that forms the root of the URL required to make API calls. The base path value in the example code is set to target the developer environment at
https://<domain>/restapi/v2
Where <domain> is demo.rooms.docusign.com for the developer environment and rooms.docusign.com for production.
{FORM_ID}A GUID value that identifies the form to attach to a room. To return a list of your form IDs, use the FormLibraries:GetFormLibraries method.
Forms enabled on your Rooms accountThe user role needs the AddDocumentsFromFormGroupToRooms or AddDocumentsFromFormLibrariesToRooms permission assigned. These permissions are only available to accounts with Forms enabled. To enable this feature, contact your Account Manager or Business Development representative.
{ROOM_ID}A unique integer that identifies your room. To return a list of your room IDs, use the Rooms:GetRooms method.
Rooms enabled for your accountYou will need access enabled to use the Rooms API. See creating a Rooms developer account.

Step 1. Obtain your OAuth token

To make the API call shown in this how-to, you need a valid OAuth access token with the dtr.rooms.write scope enabled. Docusign supports access tokens for three different recommended OAuth grant types: Public Authorization Code Grant, Confidential Authorization Code Grant, and JSON Web Token (JWT) Grant. Choose the OAuth grant type appropriate for your scenario.

See Authentication for guidance on your options to get an OAuth token.

Three icons that represent the three methods a user can use to obtain an OAuth token: JSON Web Token (JWT), Public Authorization Code Grant (ACG), and Confidential Authorization Code grant

Step 2. Construct your API headers

After you have a valid OAuth access token, you are ready to construct the API headers that you will pass to the API call. Construct your headers like this, but make sure to substitute your valid OAuth access token for {ACCESS_TOKEN}.

declare -a Headers=('--header' "Authorization: Bearer ${ACCESS_TOKEN}"
'--header' "Accept: application/json"
'--header' "Content-Type: application/json")

Step 3. Obtain the desired form ID

Rooms accounts have forms bundled into objects known as FormLibraries.

Note: Your account needs to have access to documents and forms data; otherwise, you will be unable to retrieve a form ID from the FormLibraries resource.

Retrieve your intended form ID from the libraryFormId. Here’s how you make the call, but make sure to substitute your API account ID for {ACCOUNT_ID}

printf \
'{
"formId":"'"$library_form_id"'",
}' >$request_data

Step 4. Call the Rooms API

Now that you have a form ID, make a POST request to the Rooms:AddFormToRoom endpoint to attach the form to your room by specifying the aforementioned form ID in the request body.

Note: When adding forms to rooms, each form ID must be unique or the form will fail to be added.

Status=$(curl -w '%{http_code}' -i --request POST "https://demo.rooms.docusign.com/restapi/v2/accounts/${account_id}/rooms/${room_id}/forms" \
"${Headers[@]}" \
--data-binary @${request_data} \
--output ${response})

Expected response

If your API call is successful, you should see a JSON response similar to this.

View the source code for this how-to on GitHub: Bash, C#, Java, Node, PHP, PowerShell, Python, or Ruby.

Sample response
{
"documentId": 3xxxx4,
"name": "LREC - Residential Purchase Agreement.pdf",
"ownerId": 2xxxx4,
"size": 0,
"createdDate": "2020-08-06T20:46:06.973",
"isSigned": false,
"docuSignFormId": "6ab833df-xxxx-xxxx-xxxx-9576243ca995",
"isArchived": false
}

Next steps